#import "MobpushPlugin.h"
#import <MobPush/MobPush.h>
#import <MobPush/MobPush+Test.h>
#import <MobPush/MPushNotificationConfiguration.h>
#import <MOBFoundation/MOBFoundation.h>

@implementation MobpushPlugin
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"mobpush_plugin"
            binaryMessenger:[registrar messenger]];
  MobpushPlugin* instance = [[MobpushPlugin alloc] init];
  [registrar addMethodCallDelegate:instance channel:channel];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
  if ([@"getPlatformVersion" isEqualToString:call.method]) {
    result([@"iOS " stringByAppendingString:[[UIDevice currentDevice] systemVersion]]);
  } else if ([@"getRegistrationId" isEqualToString:call.method]) {
    [MobPush getRegistrationID:^(NSString *registrationID, NSError *error) {
      if (error) {
        NSLog(@"### getRegistrationId Error: %@", error.description);
        result(nil);
      }
      if (result)
      {
        NSLog(@"### registrationID: %@", registrationID);
        result(registrationID);
      }
    }];
  } else {
    result(FlutterMethodNotImplemented);
  }
}

@end
